The Synthesis ToolKit in C++ (STK)

Home Information Classes Download Usage Mail List Requirements Links FAQ Tutorial

Public Member Functions | List of all members
stk::Cubic Class Reference

STK cubic non-linearity class. More...

`#include <Cubic.h>`

Inheritance diagram for stk::Cubic:

## Public Member Functions
| Cubic (void)
| Default constructor.
void | setA1 (StkFloat a1)
| Set the a1 coefficient value.
void | setA2 (StkFloat a2)
| Set the a2 coefficient value.
void | setA3 (StkFloat a3)
| Set the a3 coefficient value.
void | setGain (StkFloat gain)
| Set the gain value.
void | setThreshold (StkFloat threshold)
| Set the threshold value.
StkFloat | tick (StkFloat input)
| Input one sample to the function and return one output.
StkFrames & | tick (StkFrames &frames, unsigned int channel=0)
| Take a channel of the StkFrames object as inputs to the function and replace with corresponding outputs.
StkFrames & | tick (StkFrames &iFrames, StkFrames &oFrames, unsigned int iChannel=0, unsigned int oChannel=0)
| Take a channel of the `iFrames` object as inputs to the function and write outputs to the `oFrames` object.
Public Member Functions inherited from stk::Function
| Function (void)
| Class constructor.
StkFloat | lastOut (void) const
| Return the last computed output sample.
virtual StkFloat | tick (StkFloat input)=0
| Take one sample input and compute one sample of output.
Public Member Functions inherited from stk::Stk
void | ignoreSampleRateChange (bool ignore=true)
| A function to enable/disable the automatic updating of class data when the STK sample rate changes.

## Additional Inherited Members
Static Public Member Functions inherited from stk::Stk
static StkFloat | sampleRate (void)
| Static method that returns the current STK sample rate.
static void | setSampleRate (StkFloat rate)
| Static method that sets the STK sample rate.
static void | clear_alertList ()
| Static method that frees memory from alertList_.
static std::string | rawwavePath (void)
| Static method that returns the current rawwave path.
static void | setRawwavePath (std::string path)
| Static method that sets the STK rawwave path.
static void | swap16 (unsigned char *ptr)
| Static method that byte-swaps a 16-bit data type.
static void | swap32 (unsigned char *ptr)
| Static method that byte-swaps a 32-bit data type.
static void | swap64 (unsigned char *ptr)
| Static method that byte-swaps a 64-bit data type.
static void | sleep (unsigned long milliseconds)
| Static cross-platform method to sleep for a number of milliseconds.
static bool | inRange (StkFloat value, StkFloat min, StkFloat max)
| Static method to check whether a value is within a specified range.
static void | handleError (const char *message, StkError::Type type)
| Static function for error reporting and handling using c-strings.
static void | handleError (std::string message, StkError::Type type)
| Static function for error reporting and handling using c++ strings.
static void | showWarnings (bool status)
| Toggle display of WARNING and STATUS messages.
static void | printErrors (bool status)
| Toggle display of error messages before throwing exceptions.
Static Public Attributes inherited from stk::Stk
static const StkFormat | STK_SINT8
static const StkFormat | STK_SINT16
static const StkFormat | STK_SINT24
static const StkFormat | STK_SINT32
static const StkFormat | STK_FLOAT32
static const StkFormat | STK_FLOAT64
Protected Member Functions inherited from stk::Stk
| Stk (void)
| Default constructor.
virtual | ~Stk (void)
| Class destructor.
virtual void | sampleRateChanged (StkFloat newRate, StkFloat oldRate)
| This function should be implemented in subclasses that depend on the sample rate.
void | addSampleRateAlert (Stk *ptr)
| Add class pointer to list for sample rate change notification.
void | removeSampleRateAlert (Stk *ptr)
| Remove class pointer from list for sample rate change notification.
void | handleError (StkError::Type type) const
| Internal function for error reporting that assumes message in `oStream_` variable.

## Detailed Description

STK cubic non-linearity class.

This class implements the cubic non-linearity that was used in SynthBuilder.

The formula implemented is:

output = gain * (a1 * input + a2 * input^2 + a3 * input^3)

followed by a limiter for values outside +-threshold.

Ported to STK by Nick Porcaro, 2007. Updated for inclusion in STK distribution by Gary Scavone, 2011.

## Member Function Documentation

## ◆ tick() [1/2]

StkFrames & stk::Cubic::tick | ( | StkFrames & | frames,
|  | unsigned int | channel = `0`
| ) |  |
| inline

Take a channel of the StkFrames object as inputs to the function and replace with corresponding outputs.

The StkFrames argument reference is returned. The `channel` argument must be less than the number of channels in the StkFrames argument (the first channel is specified by 0). However, range checking is only performed if STK_DEBUG is defined during compilation, in which case an out-of-range value will trigger an StkError exception.

100{
101#if defined(_STK_DEBUG_)
102 if ( channel >= frames.channels() ) {
103 oStream_ << "Cubic::tick(): channel and StkFrames arguments are incompatible!";
104 handleError( StkError::FUNCTION_ARGUMENT );
105 }
106#endif
107
108 StkFloat *samples = &frames[channel];
109 unsigned int hop = frames.channels();
110 for ( unsigned int i=0; i<frames.frames(); i++, samples += hop )
111 *samples = tick( *samples );
112
113 lastFrame_[0] = *(samples-hop);
114 return frames;
115}
stk::Cubic::tick
StkFloat tick(StkFloat input)
Input one sample to the function and return one output.
Definition Cubic.h:84
stk::Stk::handleError
static void handleError(const char *message, StkError::Type type)
Static function for error reporting and handling using c-strings.

## ◆ tick() [2/2]

StkFrames & stk::Cubic::tick | ( | StkFrames & | iFrames,
|  | StkFrames & | oFrames,
|  | unsigned int | iChannel = `0`,
|  | unsigned int | oChannel = `0`
| ) |  |
| inline

Take a channel of the `iFrames` object as inputs to the function and write outputs to the `oFrames` object.

The `iFrames` object reference is returned. Each channel argument must be less than the number of channels in the corresponding StkFrames argument (the first channel is specified by 0). However, range checking is only performed if STK_DEBUG is defined during compilation, in which case an out-of-range value will trigger an StkError exception.

118{
119#if defined(_STK_DEBUG_)
120 if ( iChannel >= iFrames.channels() || oChannel >= oFrames.channels() ) {
121 oStream_ << "Cubic::tick(): channel and StkFrames arguments are incompatible!";
122 handleError( StkError::FUNCTION_ARGUMENT );
123 }
124#endif
125
126 StkFloat *iSamples = &iFrames[iChannel];
127 StkFloat *oSamples = &oFrames[oChannel];
128 unsigned int iHop = iFrames.channels(), oHop = oFrames.channels();
129 for ( unsigned int i=0; i<iFrames.frames(); i++, iSamples += iHop, oSamples += oHop )
130 *oSamples = tick( *iSamples );
131
132 lastFrame_[0] = *(oSamples-oHop);
133 return iFrames;
134}

The documentation for this class was generated from the following file:

- Cubic.h

The Synthesis ToolKit in C++ (STK)
©1995--2023 Perry R. Cook and Gary P. Scavone. All Rights Reserved.